package com.ho.test.xpath.jaxp;


/**
 * XPATH with the standard use of the API JAXP (included in JDK). 
 * 
 * <p>Title: TestXPath_JAXPChecker</p>
 * <p>Copyright: Copyright (c) 2012</p>
 * @author Huseyin OZVEREN
 */
public class TestXPath_JAXPChecker {

	public static void main(String[] args) {

		String entryFile = "file:./src/com/ho/test/xpath/xmlFile.xml";
		StringBuffer xpathExpression = new StringBuffer("");

		
		System.out.println(" -------------------- Example N1 -----------------------------");
		xpathExpression = new StringBuffer("/HUOXml/rootTag/docType[memo!='AA' and memo!='aa']");
		executeXpath(entryFile, xpathExpression.toString());
		
		System.out.println(" -------------------- Example N2 -----------------------------");
		xpathExpression = new StringBuffer("/HUOXml[./rootTag/docType[memo!='AA' and memo!='aa'] and ./version/languageCouples/languageCouple/targetLanguage='bg']");
		executeXpath(entryFile, xpathExpression.toString());

		System.out.println(" -------------------- Example N3 -----------------------------");
		xpathExpression = new StringBuffer("/HUOXml/rootTag/docType[myRQ = 'JAVABLOG']");
		executeXpath(entryFile, xpathExpression.toString());
		
		System.out.println(" -------------------- Example N4 -----------------------------");
		xpathExpression = new StringBuffer("/HUOXml/version/languageCouples/languageCouple[./targetLanguage = 'en']");
		executeXpath(entryFile, xpathExpression.toString());

		System.out.println(" -------------------- Example N5 -----------------------------");
		xpathExpression = new StringBuffer("/HUOXml[./rootTag/docType[memo!='RRRR' and memo!='rrrr' ] " +
				" and ./version/languageCouples/languageCouple[(./@targetLanguage='IT' or ./@targetLanguage='it') and (./@inform='Yes')] " +
				" and ./version[( ( starts-with(./myCode,'huo-') or  starts-with(./myCode,'HUO-') )=false )]]");
		executeXpath(entryFile, xpathExpression.toString());
	}
	
	
	private static String executeXpath(String entryFile, String xpathExpression){
		String result = null;
		try{
			System.out.println("------ File: '"+entryFile+"'");
			System.out.println("------ Xpath Expression: '"+xpathExpression+"'");
	
			// 1. Instantiate an XPathFactory.
			javax.xml.xpath.XPathFactory factory = javax.xml.xpath.XPathFactory.newInstance();
				  
			// 2. Use the XPathFactory to create a new XPath object
			javax.xml.xpath.XPath xpath = factory.newXPath();
				  
			// 3. Compile an XPath string into an XPathExpression
			javax.xml.xpath.XPathExpression expression = xpath.compile(xpathExpression.toString());
				  
			// 4. Evaluate the XPath expression on an input document
			result = expression.evaluate(new org.xml.sax.InputSource(entryFile));
			System.out.println("Return : " + result);
		} catch (Throwable e) {
			e.printStackTrace();
		}
		return result;
	}
	
}
