package com.ho.test.xpath.jdom;

import java.io.File;
import java.util.Iterator;
import java.util.List;

import org.jdom.Element;
import org.jdom.input.SAXBuilder;
import org.jdom.xpath.XPath;

/**
 * XPATH with the standard use of the API JDOM (jdom.jar)
 * 
 * <p>Title: TestXPath_JDOMChecker</p>
 * <p>Copyright: Copyright (c) 2012</p>
 * @author Huseyin OZVEREN
 */
public class TestXPath_JDOMChecker {

	public static void main(String[] args) {

		String entryFileName = "./src/com/ho/test/xpath/xmlFile.xml";

		{
			System.out.println(" -------------------- Example N1 -----------------------------");
			StringBuffer xpathExpression = new StringBuffer("/HUOXml/rootTag/docType[myRQ = 'JAVABLOG']");
			TestXPath_JDOMChecker.executeXpath(entryFileName, xpathExpression.toString());
		}
		
		{
			System.out.println(" -------------------- Example N2 -----------------------------");
			StringBuffer xpathExpression = new StringBuffer("/HUOXml/rootTag/docType[myRQ = 'JAVA' or myRQ = 'JAVABLOG']");
			TestXPath_JDOMChecker.executeXpath(entryFileName, xpathExpression.toString());
		}
		
		{
			System.out.println(" -------------------- Example N3 -----------------------------");
			StringBuffer xpathExpression = new StringBuffer("/HUOXml/rootTag/docType[myRQ != 'TUTU' and myRQ != 'TODO']");
			TestXPath_JDOMChecker.executeXpath(entryFileName, xpathExpression.toString());
		}
		
		{
			System.out.println(" -------------------- Example N4 -----------------------------");
			StringBuffer xpathExpression = new StringBuffer("/HUOXml/version/languageCouples/languageCouple[@targetLanguage = 'fr']");
			TestXPath_JDOMChecker.executeXpath(entryFileName, xpathExpression.toString());
		}
		
		{
			System.out.println(" -------------------- Example N5 -----------------------------");
			StringBuffer xpathExpression = new StringBuffer("/HUOXml/rootTag");
			xpathExpression.append("[");
			xpathExpression.append("./docType/myRQ != 'TODO'");
			xpathExpression.append(" and /HUOXml/version/languageCouples/languageCouple[@targetLanguage='bg' and @inform='Yes'] ");
			xpathExpression.append("]/number");
			TestXPath_JDOMChecker.executeXpath(entryFileName, xpathExpression.toString());
		}
	}

	
	private static void executeXpath(String entryFileName, String xpathExpression){
		try{
			File entryFile = new File(entryFileName);
			
			System.out.println("------ File: '"+entryFileName+"'");
			System.out.println("------ Xpath Expression: '"+xpathExpression+"'");

			org.jdom.Document document = null;
	
			/* Create instance of SAXBuilder */
			SAXBuilder sxb = new SAXBuilder();
			document = sxb.build(entryFile);
			
			/* Initializes a new element with the root element of document. */
			Element racine = document.getRootElement();
			XPath xpa = XPath.newInstance(xpathExpression.toString());
	
			List results = xpa.selectNodes(racine);
			Iterator iter = results.iterator();
			Element noeudCourant = null;
			if(iter.hasNext()) {
				while (iter.hasNext()) {
					noeudCourant = (Element) iter.next();
					System.out.println("Value : " + noeudCourant.getValue());
				}
			}else{
				System.out.println("Value : No found!!");
				
			}
		
		} catch (Throwable e) {
			e.printStackTrace();
		}
	}
	
}
